
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>【原创】RabbitMQ 之 Dead Letter Exchanges（翻译） / iVAN</title>

    <meta name="description" content="【原创】RabbitMQ 之 Dead Letter Exchanges（翻译） Dead Letter Exchanges  Messages from a queue can be 'dead-lettered'; that is, republished to another exchange when any of the following events occur: queue 中的消息可能成为&quot;死信&quot;:也就是说,会在下面任何一种情况发生时,重新 publish 消息到另外的 exchange 中:  The message is reject ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">【原创】RabbitMQ 之 Dead Letter Exchanges（翻译）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>Dead Letter Exchanges</strong> </p>
<p>Messages from a queue can be 'dead-lettered'; that is, republished to another exchange when any of the following events occur: <br />queue 中的消息可能成为“死信”；也就是说，会在下面任何一种情况发生时，重新 publish 消息到另外的 exchange 中： 
<ul>
<li>The message is rejected (basic.reject or basic.nack) with requeue=false,<br />消息被拒绝了（通过 basic.reject 方法或 basic.nack 方法），同时设置了 requeue=false 参数，</li>
<li>The TTL for the message expires; or<br />消息本身设置了 TTL ，且达到了过期时间；或者</li>
<li>The queue length limit is exceeded.queue <br />可持有消息数量达到了上限。</li>
</ul>
<p>Dead letter exchanges (DLXs) are normal exchanges. They can be any of the usual types and are declared as usual. <br /><strong>死信 exchang（DLXs）就是普通的 exchange 。</strong>其如普通 exchange 一样具有各种类型，也具有一样的声明方式。 </p>
<p>For any given queue, a DLX can be defined by clients using the queue's arguments, or in the server using policies. In the case where both policy and arguments specify a DLX, the one specified in arguments overrules the one specified in policy. <br />对于任何给定的 queue ，客户端可以通过 queue 的 argument 参数指定 DLX ，或者直接在服务器侧 通过 <a href="http://www.rabbitmq.com/parameters.html#policies" rel="external nofollow noreferrer">policy</a> 来 创建。<strong>如果出现同时使用两种方式创建了 DLX 的情况，则通过 argument 指定的 DLX 优先采用</strong>。 </p>
<p><strong>Configuration using arguments</strong> <br /><strong>通过 argument 方式进行配置</strong> </p>
<p>To set the dead letter exchange for a queue, set the x-dead-letter-exchange argument to the name of the exchange: <br />如果要为某个 queue 设置 DLX ，则需要将 <strong>argument x-dead-letter-exchange</strong> 设置为 exchange 的名字： </p>
<p><a href="http://my.oschina.net/moooofly/blog/382387#" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5
</td>
<td>
<p><code>channel.exchangeDeclare(</code><code>"some.exchange.name"</code><code>, </code><code>"direct"</code><code>);</code></p>
<p> </p>
<p><code>Map&lt;String, Object&gt; args = </code><code>new</code> <code>HashMap&lt;String, Object&gt;();</code></p>
<p><code>args.put(</code><code>"x-dead-letter-exchange"</code><code>, </code><code>"some.exchange.name"</code><code>);</code></p>
<p><code>channel.queueDeclare(</code><code>"myqueue"</code><code>, </code><code>false</code><code>, </code><code>false</code><code>, </code><code>false</code><code>, args);</code></p>
</td>
</tr>
</tbody>
</table>
<p>The code above declares a new exchange called some.exchange.name and sets this new exchange as the dead letter exchange for a newly created queue. Note that the exchange does not have to be declared when the queue is declared, but it should exist by the time messages need to be dead-lettered; if it is missing then, the messages will be silently dropped. <br />上述代码声明了一个新的名为 some.exchange.name 的 exchange ，并且将该 exchange 设置成一个新创建 queue 的 DLX 。值得注意的是，当 queue 被声明的时候，该 exchange 并不要求已经被声明完成，但是当消息需要被当做“死信”处理的时候，该 exchange 必须已经存在。如果仍旧未存在，此时消息将被悄悄的丢掉（blackholed）。 </p>
<p>You may also specify a routing key to be used when dead-lettering messages. If this is not set, the message's own routing keys will be used. <br />你同样<strong>可以指定一个 routing key 用于 DLX 分发消息。如果没有指定，那么消息本身使用的 routing key 将被使用。</strong> </p>
<p><a href="http://my.oschina.net/moooofly/blog/382387#" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1
</td>
<td>
<p><code>args.put(</code><code>"x-dead-letter-routing-key"</code><code>, </code><code>"some-routing-key"</code><code>);</code></p>
</td>
</tr>
</tbody>
</table>
<p>When a dead letter exchange has been specified, in addition to the usual configure permissions on the declared queue, the user needs to have read permissions on that queue and write permissions on the dead letter exchange. Permissions are verified at the time of queue declaration. <br />当 DLX 被指定好后，对于被声明的 queue 而言，除了通常所需的 configure 权限，用户还需要具有对于该 queue 的 read 权限，和对于 DLX 的 write 权限。相应权限会在 queue 声明的时候被验证。 </p>
<p><strong>Configuration using policy</strong><br /><strong>通过 policy 进行配置</strong> </p>
<p>To specify a DLX using policy, add the key "dead-letter-exchange" to a policy definition. For example: <br />通过 policy 来指定 DLX ，则需要在 policy 定义中添加 <strong>dead-letter-exchange</strong> 这个 key 值。例如： <br />
<table>
<tbody>
<tr>
<td>
rabbitmqctl
</td>
<td>
rabbitmqctl set_policy DLX ".*" '{"dead-letter-exchange":"my-dlx"}' --apply-to queues
</td>
</tr>
<tr>
<td>
rabbitmqctl (Windows)
</td>
<td>
rabbitmqctl set_policy DLX ".*" "{""dead-letter-exchange"":""my-dlx""}" --apply-to queues
</td>
</tr>
</tbody>
</table>
<p>This applies the DLX "my-dlx" to all queues. <br />上述配置将 DLX "my-dlx" 设置给所有 queue 。 </p>
<p>Similarly, an explicit routing key can be specified by adding the key "dead-letter-routing-key" to the policy. <br />同样地，可以通过添加 key 值 <strong>dead-letter-routing-key</strong> 到 policy 中以显式指定 routing key 。 </p>
<p>Policies can also be defined using the management plugin, see the policy documentation for more details. <br />policy 还可以通过管理插件进行定义，详情请 参考 <a href="http://www.rabbitmq.com/parameters.html#policies" rel="external nofollow noreferrer">policy</a><a href="http://www.rabbitmq.com/parameters.html#policies" rel="external nofollow noreferrer"> 文档</a>。</p>
<p><strong>Routing Dead-Lettered Messages</strong> <br /><strong>死信消息的路由</strong> </p>
<p>Dead-lettered messages are routed to their dead letter exchange either: <br />死信消息将会按照下面的方式被路由到其对应的 DLX 中： 
<ul>
<li>with the routing key specified for the queue they were on; or, if this was not set,<br />如果设置 DLX 时指定了 routing key ，则使用该 key 进行路由；</li>
<li>with the same routing keys they were originally published with.<br />如果设置 DLX 时没有指定 routing key ，则使用消息被 publish 时采用的 key 。</li>
</ul>
<p>For example, if you publish a message to an exchange with routing key foo, and that message is dead-lettered, it will be published to its dead letter exchange with routing key foo. If the queue the message originally landed on had been declared with x-dead-letter-routing-key set to bar, then the message will be published to its dead letter exchange with routing key bar. <br />例如，如果你使用 foo 作为 routing key 去 publish 了一条消息，并且发生了“死信”，那么该消息将被 publish 到其对应的 DLX 中将 foo 作为 routing key 进行路由。如果消息的目标 queue 在声明的时候设置了 x-dead-letter-routing-key 为 bar 到 argument 中，那么消息最终会使用 bar 作为 routing key 将消息发送到 DLX 中。 </p>
<p>Note that, if a specific routing key was not set for the queue, messages on it are dead-lettered with all their original routing keys. This includes routing keys added by the CC and BCC headers (see Sender-selected distribution for details on these two headers). <br />值得注意的是，如果没有为 queue 设置特定的 routing key ，那么发送到该 queue 的消息在发生“死信”情况时，将分别使用其相应的 routing key 。这些 routing key 包括由 CC 和 BCC 头添加的那些（ 详情参考 <a href="http://www.rabbitmq.com/sender-selected.html" rel="external nofollow noreferrer">Sender-selected distribution</a> 中对这两个头的说明） </p>
<p>Dead-lettered messages are re-published with publisher confirms turned on internally so, the dead-letter queues the messages eventually land on must confirm the messages before they are removed from the original queue. In other words, the publishing queue will not remove messages before the dead-letter queues acknowledge receiving them (see Confirms for details on the guarantees made). Note that, in the event of an unclean broker shutdown, the same message may be duplicated on both the original queue and on the dead-letter queues. <br /><strong>死信消息被重新 publish 时默认使用了 publisher confirm 机制</strong>，也就是说，保存死信的 queue 需要对这些消息进行 confirm ，才能使得消息被原始 queue 移除。换句话说，publish 到目标 queue 中的消息，在出现死信情况后，只有在死信 queue 对重新 publish 的消息进行了 confirm 之后，才会将消息移除（详情参 <strong></strong>考 <a href="http://www.rabbitmq.com/confirms.html" rel="external nofollow noreferrer">Confirms</a> 中 的说明）。值得注意的是，如果处于 unclean 状态中的 broker 发生了 shutdown ，那么原始 queue 和死信 queue 中均可能出现重复的消息。 </p>
<p>It is possible to form a cycle of dead-letter queues. For instance, this can happen when a queue dead-letters messages to the default exchange without specifiying a dead-letter routing key. Messages in such cycles (i.e. messages that reach the same queue twice) will be dropped if the entire cycle is due to message expiry. <br />利用死信 queue 构成一个循环结构是可能的一种使用情况。例如，当原始 queue 将消息按照死信处理，将其发送到默认 exchange 上，并且没有指定死信 routing key 的情况。在这个循环结构中的消息（也就是说，消息将会到达同一个 queue 两次）将会在消息自身设置的过期时间到达后被丢弃。 </p>
<p><strong>Dead-Lettered Messages</strong> <br /><strong>死信消息</strong> </p>
<p>Dead-lettering a message modifies its headers: <br />将消息处理为死信后，将会对其头部做如下修改： 
<ul>
<li>the exchange name is replaced with that of the latest dead-letter exchange,<br />exchange 名被替换成最新设置的 DLX 值，</li>
<li>the routing key may be replaced with that specified in a dead letter queue,<br />routing key 可能被替换成声明死信 queue 时指定的值，</li>
<li>if the above happens, the CC header will also be removed, and<br />如果上述情况发生了，CC 头将被移除，并且</li>
<li>the BCC header will be removed as per Sender-selected distribution.<br />BCC 头将按照 Sender-selected distribution 中的要求被移除。</li>
</ul>
<p>The dead-lettering process adds an array to the header of each dead-lettered message named x-death. This array contains an entry for each time the message was dead-lettered. Each such entry is a table that consists of several fields: <br />死信处理进程将会在每一条死信消息的头部添加一个名为 <strong>x-death</strong> 的数组。该数组中包含每一次消息被处理为死信时的 entry 。每一个这样的 entry 都是一个由下面各域构成的表： </p>
<ul>
<li><strong>queue</strong> - the name of the queue the message was in before it was dead-lettered, <br />
              消息被作为死信处理前，应该进入的 queue 的名字，</li>
<li><strong>reason</strong> - see below,</li>
<li><strong>time</strong> - the date and time the message was dead lettered as a 64-bit AMQP format timestamp, <br />
          消息被处理为死信的日期和时间，表示为 64-bit 的 AMQP 格式时间戳，</li>
<li><strong>exchange</strong> - the exchange the message was published to (note that this will be a dead letter exchange if the message is dead lettered multiple times), and <br />
                   消息应该 publish 到的 exchange 名（值得注意的是，该值在消息作为死信处理多次的情况下将会变为 DLX 的名字）</li>
<li><strong>routing-keys</strong> - the routing keys (including CC keys but excluding BCC ones) the message was published with. <br />
                        消息被 publish 时使用的 routing key 值（包括 CC key 但不包括 BCC 值）。</li>
<li><strong>original-expiration</strong> (if the message was dead-letterered du<strong></strong>e to <a href="http://www.rabbitmq.com/ttl.html#per-message-ttl" rel="external nofollow noreferrer">per-message TTL</a>) - the original expiration property of the message. The expiration property is removed from the message on dead-lettering in order to prevent it from expiring again in any queues it is routed to.<br />初始过期时间（由于消息自身 TTL 到期而变为死信的情况） - 消息的原始过期时间属性。过期属性将会在消息被处理为死信时移除，以方式消息在死信 queue 中再次过期。</li>
</ul>
<p>The reason is a name describing why the message was dead-lettered and is one of the following: <br />上面没有说明的 reason 值，实际上是一个描述为何消息作为死信处理的字段，可能为以下的值： 
<ul>
<li>rejected - the message was rejected with requeue=false, <br />
                消息被带有 requeue=false 的信令所拒绝，</li>
<li>expired - the TTL of the message expired; or <br />
                消息 的 TTL 到期；或者</li>
<li>maxlen - the maximum allowed queue length was exceeded. <br />
               保存消息的 queue 的长度达到了上限。</li>
</ul>
<p>Note that the array is sorted most-recent-first, so the most recent dead-lettering will be recorded in the first entry. <br />值得注意的是，上面提到的数组是按照 most-recent-first 来排序的，故最新的死信消息将会被记录到第一个 entry 中。 </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-28 17:25:59</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/exchange/" title="exchange">exchange</a>, <a href="https://www.iamivan.net/tag/rabbitmq/" title="RabbitMQ">RabbitMQ</a>, <a href="https://www.iamivan.net/tag/dlx/" title="DLX">DLX</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>【原创】RabbitMQ 之 Dead Letter Exchanges（翻译）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b24KWVp.html" rel="bookmark">【原创】RabbitMQ 之 Federation 插件（翻译）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Federation Plugin   Introduction简介 The high-level goal of the federation plugin is to transmit messages between brokers without requiring clustering. This is useful for various reasons:federation 插件的 high level 目标是,在不同 broker 之间进行消息传递而无需建立集群:该功能在很多场景			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPPQa8p.html" rel="bookmark">【原创】RabbitMQ 之 Access Control（翻译）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Access Control  When the server first starts running, and detects that its database is uninitialised or has been deleted, it initialises a fresh database with the following resources: 当服务器启动运行后,检测到所使用的数据库未进行过初始化,或者被删除了,则会使用如下资源初始化一个新的数据库:  a virtual			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7ZxY4p.html" rel="bookmark">【原创】RabbitMQ 之 Distributed brokers（翻译）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Distributed RabbitMQ brokers  AMQP and the other messaging protocols supported by RabbitMQ via plug-ins (e.g. STOMP), are (of course) inherently distributed - it is quite common for applications from multiple machines to connect to a single broker, e			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrWVOjp.html" rel="bookmark">【原创】RabbitMQ 之 SASL Authentication（翻译）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				SASL Authentication RabbitMQ has pluggable support for various SASL authentication mechanisms. There are three such mechanisms built into the server: PLAIN, AMQPLAIN, and RABBIT-CR-DEMO, and one - EXTERNAL - available as a plugin. You can also implem			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze6vx7b.html" rel="bookmark">【原创】RabbitMQ 之 Negative Acknowledgements（翻译）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Negative Acknowledgements The AMQP specification defines the basic.reject method that allows clients to reject individual, delivered messages, instructing the broker to either discard them or requeue them. Unfortunately, basic.reject provides no supp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE42AZz.html" rel="bookmark">【原创】RabbitMQ 之 Dynamic Shovel（翻译）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Configuring Dynamic Shovels  Information about dynamic shovels is stored in the RabbitMQ database, along with users, permissions, queues, etc. Every shovel is defined by a corresponding named parameter. dynamic shovel 的配置信息会被保存到 Mnesia 中,信息中会包含 user,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bByoeOz.html" rel="bookmark">【原创】RabbitMQ 之 Publisher Acknowledgement（翻译）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Confirms (aka Publisher Acknowledgements)       Using standard AMQP, the only way to guarantee that a message isn't lost is by using transactions -- make the channel transactional, publish the message, commit. In this case, transactions are unnecessa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M94REgb.html" rel="bookmark">【原创】rabbitmq-env&period;conf用户手册（翻译）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				官方原文:http://www.rabbitmq.com/man/rabbitmq-env.conf.5.man.html =============== 我是分割线 ================ 名字 rabbitmq-env.conf - RabbitMQ AMQP server 的默认配置文件 描述       /etc/rabbitmq/rabbitmq-env.conf 中包含了各种设置项,可以用于覆盖在 RabbitMQ 启动脚本中默认设置的相关选项.        该文件由系统			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvm6kAb.html" rel="bookmark">【原创】RabbitMQ之PublisherConfirm实战问题总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如何理解Publisher Confirm机制       Publisher Confirm机制(又称为Confirms或Publisher Acknowledgements)是作为解决事务机制性能开销大(导致吞吐量下降)而提出的另外一种保证消息不会丢失的方式. Publisher Confirm的协议交互过程 (补充说明:上图中未显示出info信息的两条交互对应的就是 Confirm.Select 和 Confirm.Select-ok ,显示不出来是因为 wireshark 没有对该扩展进			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbadBJz.html" rel="bookmark" class="title">android- java&period;lang&period;IllegalArgumentException&colon; x 一定要小于 bitmap&period;width&lpar;&rpar;</a>
					<div>
						问题描述 java.lang.IllegalArgumentException: x 一定要小于 bitmap.width() 获取屏幕截图,用裁剪图片创建位图的时候出现了错误, 先看看我的代码吧:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM60Qoz.html" rel="bookmark" class="title">Photoshop制作华丽的感恩教师节立体字技巧</a>
					<div>
						教程介绍多层次立体字制作方法.过程并不复杂,制作好相要的文字后,给文字添加样式做出质感.然后沿着文字边缘勾出轮廓作为立体字的一个面,然后给这个面增加立体效果,后面再逐步把这个面放大,并增加立体效果,这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9mEgM.html" rel="bookmark" class="title">摆脱SEO菜鸟行列 用心是王道</a>
					<div>
						对于本身SEO初级的人员来讲的话,我们常规会说是一个&quot;菜鸟&quot;,当然,本人不觉得这是一个不好的词或者说一定是强加给这些初学的SEO人员的.事实上,对于菜鸟SEO来讲的话,如何把能力或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZA1Yp.html" rel="bookmark" class="title">Flash Professional 8超酷实例欣赏和剖析</a>
					<div>
						Flash 8官方发布的消息一经推出,便吸引了无数Flasher的眼光.新版的Flash 8确实有不俗的表现,不仅提供了设计方面强大的新功能,在代码方面,也有许多新增的特性等待大家去一一挖掘.Flas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPkx8z.html" rel="bookmark" class="title">轻松配置Windows7&sol;Ubuntu9双系统</a>
					<div>
						一.安装Windows 7 二.安装Ubuntu 9.04 1.复制Ubuntu 9.04光盘镜像文件到C盘根目录 2.复制镜像文件中casper目录下的initrd.gz和vmlinuz到C盘根目录 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7keE5z.html" rel="bookmark" class="title">WPS怎么将多行文字快速合并成一行文字&quest;</a>
					<div>
						  WPS怎么将多行文字快速合并成一行文字?          1.在计算机桌面的Wps演示图标上双击鼠标左键,将其打开运行.如图所示; 2.在打开的Wps演示程序窗口,打开&quot;插入&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwL5Znb.html" rel="bookmark" class="title">win7系统怎么用打印机扫描仪功能</a>
					<div>
						  win7系统怎么用打印机扫描仪功能         具体方法如下: 1.打开扫描仪盖板,放入自己要扫描的证件,然后从电脑端打开我的电脑,驱动安装好之后,这里会有一个扫描仪的盘符,类似光驱的位置;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24m43p.html" rel="bookmark" class="title">有道云笔记怎么设置锁定密码</a>
					<div>
						  1.打开有道云笔记,点击设置按钮 2.弹出一个窗口后选择锁定设置 3.输入锁定有道云笔记密码,下列选择选项根据情况,进行选择 4.锁定密码设定完成之后,进行验证是否设置成功,点击右上角最小化或者点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72Lqqp.html" rel="bookmark" class="title">steam平台如何设置中文</a>
					<div>
						  steam平台怎么设置中文 1.登录steam后,点击steam左上角的&quot;steam&quot;图标,在弹出的菜单中点击&quot;Settings&quot;. 2.在弹出的设置中选择 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQKgOp.html" rel="bookmark" class="title">eclipse启动tomcat报错</a>
					<div>
						问题描述 eclipse启动tomcat报错 一下报错信息:FATAL ERROR in native method: JDWP No transports initialized jvmtiErro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZRQAb.html" rel="bookmark" class="title">《Ember&period;js实战》&mdash;&mdash;2&period;6　Ember&period;js实现各层间数据同步</a>
					<div>
						2.6 Ember.js实现各层间数据同步 本章前面我们看到了一个数据同步模型,其可以确保数据始终在客户端和服务器端之间保持同步(见图2-2).在这个模型中,应用程序8个步骤中就有6个需要显式跟踪并关 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxNOEb.html" rel="bookmark" class="title">项目-找工作 需要有C 或c&plus;&plus;的开发经验 怎么办</a>
					<div>
						问题描述 找工作 需要有C 或c++的开发经验 怎么办 本人是应届硕士,但是都是理论多 没动手实际开发过项目 ,主要是C语言的 但是公司都要求有开发经验,所以想自己上网学一个开发过程-- 因为从网上看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6kBlz.html" rel="bookmark" class="title">ajax-运行时错误&colon; 对象不支持此属性或方法</a>
					<div>
						问题描述 运行时错误: 对象不支持此属性或方法 这个问题怎么解决啊 解决方案 不支持.肯定是你掉错了,检查下 解决方案二: js报错了,隔几行加一个alert,找到具体哪行报的错,这样看没看出什么问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2kGrb.html" rel="bookmark" class="title">obj-c编程15&lbrack;Cocoa实例01&rsqb;&colon;一个会发声的随机数生成器</a>
					<div>
						    哇!终于到了obj-c编程系列的第15篇喽,一路走过来满不容易的哦!(怎么个意思,这才哪到哪啊!),为了能够更好的练习obj-c在Cocoa框架上的编程,接下来会以N篇Cocoa实例的博文来巩 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgR9Nmb.html" rel="bookmark" class="title">三星GALAXY E7如何设置按主页键接听电话&quest;&lpar;E7000&rpar;</a>
					<div>
						1. 在待机页面下,点击[电话].   2. 点击屏幕右上角[菜单]键,选择[设定].   3. 点击[通话].   4. 点击[接听和结束通话].   5. 点击[按下主页键]将其勾选,即可开启按下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKyDBb.html" rel="bookmark" class="title">php异步多线程swoole使用实例程序</a>
					<div>
						Swoole 提供了PHP语言的异步多线程服务器,异步TCP/UDP网络客户端,异步MySQL,数据库连接池,AsyncTask,消息队列,毫秒定时器,异步文件读写,异步DNS查询. swoole以前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Ranob.html" rel="bookmark" class="title">Android 定位服务</a>
					<div>
						今天因为工作需要,把以前编写的一个GPS测试程序拿出来重新修改了一下.这个程序说起来有些历史了,是我11年编写的,那时候学了Android开发没多久,算是一个实验性的作品.现在工作需要,重新拿出来修整 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgR6o5b.html" rel="bookmark" class="title">Galactic Dependencies依存关系数据集&plus;细粒度语言类型学预测 &vert; 实录&CenterDot;PhD Talk &num;06</a>
					<div>
						来源:paperweekly 原文链接					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYGZmp.html" rel="bookmark" class="title">ubuntu下vsftpd虚拟用户配置</a>
					<div>
						一.业务要求 现在要求创建一个FTP账号ailanni,该账号只能登录到/www目录下,不能切换到上级目录.同时处于安全考虑还要求该账号上传的文件权限为644,即上传的文件具有可读可写权限,但是没有可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkA0Oyb.html" rel="bookmark" class="title">zoj 1649 BFS</a>
					<div>
						// zoj 1649 #include&lt;stdio.h&gt; #include&lt;queue&gt; #include&lt;string.h&gt; using namespace s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLAYDM.html" rel="bookmark" class="title">svn导出项目后报错汇总</a>
					<div>
						1.jsp页面内:标点符号,引入报错 解决方法:关闭此项目的jsp验证,右键,最下面一个,Verification,右边一溜只留一个dtd就好 2. 编码问题-乱码        刚拉下来的项目编码可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgy7OM.html" rel="bookmark" class="title">BAT 人工智能大战升级，度秘事业部总经理景鲲详解百度&OpenCurlyDoubleQuote;All in AI&rdquo;</a>
					<div>
						3月30日,百度发布了DuerOS智慧芯片,百度官方称,这将&quot;完善智能物联网生态,开启'可对话'智慧设备时代&quot;. 发布会上,百度宣布与紫光展锐.ARM.上海汉枫达成战略合作.具体讲 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKEX9p.html" rel="bookmark" class="title">黄静案今日开庭：申请拘留处罚原律师</a>
					<div>
						计世网26日消息,今天下午,黄静诉崔电博.北京浩光律师事务所.北京包诚律师事务所名誉权纠纷一案将在北京市宣武区人民法院最后一次开庭审理. 黄静方表示,因认为被告方故意在民事诉讼审理中提供虚假证据,将在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQodnp.html" rel="bookmark" class="title">&lbrack;LeetCode&rsqb;109&period;Convert Sorted List to Binary Search Tree</a>
					<div>
						[题目] Given a singly linked list where elements are sorted in ascending order, convert it to a height ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZB9loz.html" rel="bookmark" class="title">韩娱每周一星：Se7en斗志不灭越挫越勇&lpar;组图&rpar;</a>
					<div>
						编者按:在汰旧换新速度飞快的娱乐界,人气的保质期是非常短暂的.今天还是娱乐头条,明天可能就会被后来者取代.但不管他们的星途指向何方,最闪耀的时刻都是应该被铭记的,新浪韩娱每周一星就是要带领各位循着他们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOn4W3p.html" rel="bookmark" class="title">python求众数问题实例&lowbar;python</a>
					<div>
						本文实例讲述了python求众数问题的方法,是一个比较典型的应用.分享给大家供大家参考.具体如下: 问题描述: 多重集中重数最大的元素称为众数...就是一个可以有重复元素的集合,在这个集合中重复的次数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvWWdVp.html" rel="bookmark" class="title">TrackingLayer层绘制的图形对象怎么不保留啊&quest;</a>
					<div>
						问题描述 我利用vc6.0调试mapobjects组件,在TrackingLayer层绘制的图形对象怎么不保留啊?之前参考的是vb代码,map1.TrackingLayer.Refreshture这句 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmRjkDz.html" rel="bookmark" class="title">脚本调用OCX控件调取不到控件方法</a>
					<div>
						问题描述 &lt;objectclassid=&quot;CLSID:ED146CB6-7E14-4265-A1FC-0B5AE8D3AFCF&quot;codebase=&quot;bin/GetB ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYdDD6b.html" rel="bookmark" class="title">OpenStack并非科学项目，但仍须&OpenCurlyDoubleQuote;对各组件进行整合&rdquo;</a>
					<div>
						 一年之前,Gartner公司曾经将OpenStack定义为一个&quot;科学项目&quot;.然而在与国家计算基础设施协会的Andrew Howard进行沟通时,他结合澳大利亚规模最大的OpenS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4Y841b.html" rel="bookmark" class="title">HashMap类的JDK实现剖析</a>
					<div>
						1.结构 Map&lt;K,V&gt;是一个接口,这个接口内部还有一个接口,叫Entry&lt;K,V&gt;.HashMap中Entry接口的实现类是内部静态类:HashMap.Node,结构见下: ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
